(* The Coffee Machine (originally introduced by Milner in CCS book) *)
(* this version is adapted from Kevin Hammond description in Hume   *)
(* $Id: coffee.ls,v 1.9 2006/11/24 23:10:22 pouzet Exp $ *)
type coin = Dime | Nickel
type drinks = Coffee | Tea
type buttons = BCoffee | BTea | BCancel

let node vend drink cost v = (o1, o2) where
  match v >= cost with
      true -> 
	do emit o1 = drink
	and o2 = v - cost
      done
    | false ->
	do o2 = v done
  end
    
let node coffee coin button = (drink, return) where
  rec last v = 0
  and present
      | coin(Nickel) -> 
	do v = last v + 5 done
      | coin(Dime) -> 
	  do v = last v + 10 done
      | button(BCoffee) -> 
	  do (drink, v) = vend Coffee 10 (last v)
	  done
      | button(BTea) ->
	  do (drink, v) = vend Tea 5 (last v)
	  done
      | button(BCancel) ->
	  do v = 0
	  and emit return = last v
	  done
      end

(* this verion is equivalent but generates a better code *)
let node coffee coin button =
  let  rec last v = 0
  and present
        coin(w) ->
	  do match w with
	      Nickel -> do v = last v + 5 done
	    | Dime -> do v = last v + 10 done
	    end
	  done
    | button(b) ->
	do match b with
	    BCoffee -> do (drink, v) = vend Coffee 10 (last v) done
	  | BTea -> do (drink, v) = vend Tea 5 (last v) done
	  | BCancel -> do v = 0 and emit return = last v done
	  end
	done
    end in
    (drink, return)
  
(** programming the environment *)
  
(* producing events from the keyboard *)
let node input key = (coin, button) where
  match key with
      "N" -> do emit coin = Nickel done
    | "D" -> do emit coin = Dime done
    | "C" -> do emit button = BCoffee done
    | "T" -> do emit button = BTea done
    | "A" -> do emit button = BCancel done
    | _ -> do done
  end
    
(* printing things *)
let print_drink d =
  match d with 
      Coffee -> print_string "Coffee\n"
    | Tea -> print_string "Tea\n"
  end
    
let print_coin d =
  match d with 
      Nickel -> print_string "Nickel\n"
    | Dime -> print_string "Dime\n"
  end
    
let print_button d =
  match d with 
      BCoffee -> print_string "BCoffee\n"
    | BTea -> print_string "BTea\n"
    | BCancel -> print_string "BCancel\n"
  end
    
let print f e =
  present
      e(x) -> f x
    | _ -> ()
  end
    
let output drink return =
  print print_drink drink;
  print print_int return;
  flush stdout
    
let node main () =
  let key = read_line () in
  let (coin, button) = input key in
  let drink, return = coffee coin button in
    output drink return


